from cStringIO import StringIO

from OFS.Folder import manage_addFolder
from Products.CMFCore.utils import getToolByName
from Products.ExternalMethod.ExternalMethod import manage_addExternalMethod
from Products.WebLionLibrary.skins import deleteLayers

_externalMethodsFolderId = 'customnav_external_methods'

def _skinsTool(portal):
    return getToolByName(portal, 'portal_skins')

def _importProfile(portal, profile):
    setupTool = getToolByName(portal, 'portal_setup')
    oldContextId = setupTool.getImportContextID()
    setupTool.setImportContext('profile-Products.CustomNav:default')
    setupTool.runAllImportSteps()
    setupTool.setImportContext(oldContextId)

def install(portal):
    out = StringIO()
    print >>out, "Creating customNavtree External Method..."
    skinsTool = _skinsTool(portal)
    manage_addFolder(skinsTool, _externalMethodsFolderId)
    manage_addExternalMethod(skinsTool[_externalMethodsFolderId], 'customNavtree', 'customNavtree', 'CustomNav.nav', 'customNavtree')
    print >>out, "Importing GenericSetup profile..."
    _importProfile(portal, 'profile-Products.CustomNav:default')
    print >>out, "Successfully installed CustomNav."
    return out.getvalue()

def uninstall(portal):
    out = StringIO()

    print >>out, "Running 'uninstall' GenericSetup profile..."
    _importProfile(portal, 'profile-Products.CustomNav:uninstall')
    
    # Remove layers, since GenericSetup doesn't support doing it through a profile yet:
    print >>out, "Removing layers from portal_skins..."
    deleteLayers(_skinsTool(portal), ['customnav_portlets', _externalMethodsFolderId])
    
    print >>out, "Successfully uninstalled CustomNav."
    return out.getvalue()
